using System;
using System.Collections.Generic;
using System.Text;
using Mall.Model.Entity.User;
using Mall.Model.Extend.User;
using System.Linq;

namespace Mall.Repository.User
{
    /// <summary>
    /// 推荐供应商返佣账单明细仓储层
    /// </summary>
    public class RB_Distributor_BillDetailRepository : RepositoryBase<RB_Distributor_BillDetail>
    {

        /// <summary>
        /// 分页列表
        /// </summary>
        /// <param name="pageIndex">页码</param>
        /// <param name="pageSize">每页显示条数</param>
        /// <param name="rowCount">总条数</param>
        /// <param name="dmodel">查询条件</param>
        /// <returns></returns>
        public List<RB_Distributor_BillDetail_Extend> GetPageList(int pageIndex, int pageSize, out long rowCount, RB_Distributor_BillDetail_Extend dmodel)
        {
            string where = $@" 1=1 and {nameof(RB_Distributor_BillDetail.Status)}=0";
            if (dmodel.TenantId > 0)
            {
                where += $@" and {nameof(RB_Distributor_BillDetail.TenantId)}={dmodel.TenantId}";
            }
            if (dmodel.MallBaseId > 0)
            {
                where += $@" and {nameof(RB_Distributor_BillDetail.MallBaseId)}={dmodel.MallBaseId}";
            }
            if (dmodel.BillId > 0)
            {
                where += $@" and {nameof(RB_Distributor_BillDetail.BillId)}={dmodel.BillId}";
            }
            if (dmodel.CommissionId > 0)
            {
                where += $@" and {nameof(RB_Distributor_BillDetail.CommissionId)}={dmodel.CommissionId}";
            }
            if (!string.IsNullOrEmpty(dmodel.CommissionIds)) 
            {
                where += $@" and {nameof(RB_Distributor_BillDetail.CommissionId)} in ({dmodel.CommissionIds})";
            }

            string sql = $@"select * from RB_Distributor_BillDetail where {where} order by Id desc";
            return GetPage<RB_Distributor_BillDetail_Extend>(pageIndex, pageSize, out rowCount, sql).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Distributor_BillDetail_Extend> GetList(RB_Distributor_BillDetail_Extend dmodel)
        {
            string where = $@" 1=1 and {nameof(RB_Distributor_BillDetail.Status)}=0";
            if (dmodel.TenantId > 0)
            {
                where += $@" and {nameof(RB_Distributor_BillDetail.TenantId)}={dmodel.TenantId}";
            }
            if (dmodel.MallBaseId > 0)
            {
                where += $@" and {nameof(RB_Distributor_BillDetail.MallBaseId)}={dmodel.MallBaseId}";
            }
            if (dmodel.BillId > 0)
            {
                where += $@" and {nameof(RB_Distributor_BillDetail.BillId)}={dmodel.BillId}";
            }
            if (dmodel.CommissionId > 0)
            {
                where += $@" and {nameof(RB_Distributor_BillDetail.CommissionId)}={dmodel.CommissionId}";
            }
            if (!string.IsNullOrEmpty(dmodel.CommissionIds))
            {
                where += $@" and {nameof(RB_Distributor_BillDetail.CommissionId)} in ({dmodel.CommissionIds})";
            }

            string sql = $@"select * from RB_Distributor_BillDetail where {where} order by Id desc";
            return Get<RB_Distributor_BillDetail_Extend>(sql).ToList();
        }
    }
}
